#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <errno.h>

#include "uhumenu.h"

char value[500];

static char *twm_get_value (struct item *item, const char *key)
{
	char *v1 = get_value(item, key);
	char *v2 = value;
	if (v1 == NULL) return NULL;
	do {
		if (*v1 != '"') *v2++ = *v1;
	} while (*v1++);
	return value;
}

static void dump (FILE *f, const struct menu *menu, const char *lang, iconv_t ic, int n, const char *name)
{
	int i;
	int major = 0;
	fprintf(f, "menu \"UHU%s\"\n", name);
	fprintf(f, "{\n");
	for (i = 0; i < menu->nr; i++) {
		if (i > 0 && menu->items[i].major != major) {
			fprintf(f, "  \"\" f.nop\n");
		}
		if (!menu->items[i].issubmenu) {
			fprintf(f, "  \"%s\" f.exec \"%s%s &\"\n",
			  get_name_locale(&menu->items[i], lang, ic),
			  menu->items[i].terminal ? "xterm -e " : "",
			  twm_get_value(&menu->items[i], "Exec"));
		} else {
			fprintf(f, "  \"%s\" f.menu \"UHU%s\"\n",
			  get_name_locale(&menu->items[i], lang, ic), menu->items[i].file_name);
		}
		major = menu->items[i].major;
	}
	fprintf(f, "}\n");
	fprintf(f, "\n");
	for (i = 0; i < menu->nr; i++) {
		if (menu->items[i].issubmenu) {
			dump(f, menu->items[i].submenu, lang, ic, n+1, menu->items[i].file_name);
		}
	}
}

int write_menu_lang (const struct menu *menu, const char *path,
  const char *lang, iconv_t ic)
{
	char file[PATH_MAX];
	FILE *f;
	char buf[400];

	sprintf(file, "%s/%s", path, lang);
	if ((f = fopen(file, "w")) == NULL) {
		fprintf(stderr, "twm: fopen %s: %s\n", file, strerror(errno));
		return -1;
	}
	if (menu->nr > 0) dump(f, menu->items[0].submenu, lang, ic, 0, "");
	fclose(f);

	/* XXX FIXME */
	
	sprintf(buf, "x=$(mktemp /tmp/uhutwm.XXXXXX); tr -d '%%' <\"%s\" >\"$x\"; "
	  "tr '' 'aeiooouuuAEIOOOUUU' <\"$x\" >\"%s\"; rm \"$x\"",
	  file, file);
	system(buf);

	return 0;
}

