#ifndef UHU_MENU_H
#define UHU_MENU_H

#define _GNU_SOURCE
#include <iconv.h>

struct key_value {
	char *key;
	char *value;
	struct key_value *next;
};

struct item {
	int issubmenu;
	struct menu *submenu;
	char *file_name;
	char *file_content;
	int file_size;
	struct key_value *keys_values;
	char *wmlist;
	int major;
	int minor;
	int terminal;
	int
#ifdef UHU_MENU_CORE_ENGINE
	    valid;
#else
	    do_not_use_me_1;
#endif
};

struct menu {
	int nr;
	struct item *items;
	int
#ifdef UHU_MENU_CORE_ENGINE
	    nr_real;
#else
	    do_not_use_me;
#endif
};

struct menu *read_menu (const char *path);
int write_menu (const struct menu *menu, const char *path);
int write_menu_lang (const struct menu *menu, const char *path,
  const char *lang, iconv_t ic);

char *get_value (const struct item *item, const char *key);
char *get_name_lang (const struct item *item, const char *lang);
char *get_name_locale (const struct item *item, const char *lang, iconv_t ic);
int empty_dir (const char *path);

#endif
